// i8093W_ReadCounts.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include "..\Lib\pac_i8093W.h"
#pragma comment(lib,"..\\Lib\\pac_i8093W.lib")

#define CW_CCW				1
#define PULSE_DIRECTION		2
#define QUADRANT			3

static int slotIndex=-1;


int _tmain(int argc, _TCHAR* argv[])
{
	char ansistr[32];
	int slot = 1;
	int channel = 0;
	long counts[3],nextposition[3],position;
	int return_value=1;


	for(slot=1;slot<8;slot++)
	{
	
		if(pac_i8093W_Init(slot)==0)
		{
			slotIndex=slot;
			break;
		}
	}	


	if(slotIndex==-1)
	{
		printf("There is no i8093W at Backplane\n");
		getchar();
		exit(0);
	}
	else
	{
		printf("There is an i8093W at slot %d\n",slotIndex);
	}	


	printf("Library Version %X \n",pac_i8093W_GetLibVersion());


	for(channel=0;channel<2;channel++)
	{
		pac_i8093W_SetMode(slotIndex,channel,CW_CCW);
		pac_i8093W_SetLowPassFilter(slotIndex,channel,0);//160k hz
		pac_i8093W_SetFirstTrigPosition(slotIndex,channel,200);
		pac_i8093W_GetFirstTrigPosition(slotIndex,channel,&position);
		printf("position %ld\n",position);
		pac_i8093W_SetTrigDistance(slotIndex,channel,0,100);
		pac_i8093W_SetPresetValue(slotIndex,channel,0);
		pac_i8093W_ConfigTriggerOut(slotIndex,channel,1);
		pac_i8093W_SetExSignal(slotIndex,1);
		pac_i8093W_SetExTrigMode(slotIndex,channel,1);
		printf("\n\r 9093 firmware version = %d.\n\r",pac_i8093W_GetFirmwareVersion(slotIndex));
		pac_i8093W_ResetEncoder(slotIndex,channel);
	}

	
	while(1)
	{
		for(channel=0;channel<2;channel++)
		{
			return_value = pac_i8093W_Read32BitEncoder(slotIndex, channel, &counts[channel]); 
			pac_i8093W_ReadNextPosition(slotIndex,channel,&nextposition[channel]);
			printf("C_%01d V_%ld NP_%ld ",channel,counts[channel],nextposition[channel]);
			if(OK != return_value)
			{
				printf("ERROR! reading counts error in the channel %d, and slot %d\n", slotIndex, channel);
			}
			Sleep(100);
		}
		printf("\r");
		if(kbhit())
			if(getche()=='q')
				return 0;
	}
	getchar();

	return 0;
}


